Subject: Re: [IPV6]: ROUTE:read ifname in rt6_info_route()

From: Yuta sugiura <[email-masked]>
Date: Fri, 17 Apr 2009 12:44:13 +0900

Thank you for respons to my e-mail.
I read net-snmp's patch as reference.
How about this method?

Stephen Hemminger wrote:
> On Thu, 16 Apr 2009 18:47:04 +0200
> Andreas Schwab <[email-masked]> wrote:
>
>   
>> Stephen Hemminger <[email-masked]> writes:
>>
>>     
>>> On Thu, 16 Apr 2009 04:38:00 -0700 (PDT)
>>> David Miller <[email-masked]> wrote:
>>>
>>>       
>>>> From: Yuta sugiura <[email-masked]>
>>>> Date: Thu, 16 Apr 2009 20:05:05 +0900
>>>>
>>>>         
>>>>> Hi,
>>>>> I have a suggestion about /proc/net/IPv6_route format.
>>>>> In rt6_info_route(), interface name is treated as a maximum 8
>>>>> characters.
>>>>> But the type of (struct rt6_inf *)->u.dst.dev->name is char[IFNAMESIZ=
>>>>> 16]
>>>>> so, I think that it should change "%8s" to "%16s".
>>>>>           
>>>> Isn't there a way to pass the field length as a paramenter
>>>> to formatting functions?  Then we can just pass in
>>>> IFNAMESIZE as that parameter.
>>>>         
>>> 	seq_printf(m, " %08x %08x %08x %08x %*s\n"
>>>                    rt->rt6i_metric, atomic_read(&rt->u.dst.__refcnt),
>>>  		   rt->u.dst.__use, rt->rt6i_flags,
>>>                    IFNAMESIZE, 
>>>  		   rt->rt6i_dev ? rt->rt6i_dev->name : "")
>>>       
>> Actually since it is the last item on the line a field width does not
>> make much sense, and omitting it would print the name left justified.
>>
>> (And RT6_INFO_LEN is not used any more.)
>>
>> Andreas.
>>
>>     
>
> The issue is what happens if name is not null terminated. in this case
> I bet the kernel already handles that.
>
>   

diff --git a/net/ipv6/route.c b/net/ipv6/route.c
index 1394ddb..a532dda 100644
--- a/net/ipv6/route.c
+++ b/net/ipv6/route.c
@@ -2434,7 +2434,8 @@ static int ip6_route_dev_notify(struct notifier_block *this,
 
 #ifdef CONFIG_PROC_FS
 
-#define RT6_INFO_LEN (32 + 4 + 32 + 4 + 32 + 40 + 5 + 1)
+#define RT6_INFO_LEN (32 + 4 + 32 + 4 + 32 + 48 + 5 + 1)
+#define RT6_VAL_TO_STR(s) #s
 
 struct rt6_proc_arg
 {
@@ -2462,7 +2463,8 @@ static int rt6_info_route(struct rt6_info *rt, void *p_arg)
 	} else {
 		seq_puts(m, "00000000000000000000000000000000");
 	}
-	seq_printf(m, " %08x %08x %08x %08x %8s\n",
+	seq_printf(m, " %08x %08x %08x %08x %"
+		   RT6_VAL_TO_STR(IFNAMSIZ) "s\n",
 		   rt->rt6i_metric, atomic_read(&rt->u.dst.__refcnt),
 		   rt->u.dst.__use, rt->rt6i_flags,
 		   rt->rt6i_dev ? rt->rt6i_dev->name : "");